#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include "timer.h"


static void *xfb = NULL;
static GXRModeObj *rmode = NULL;

void *Initialise();

int main(int argc, char **argv) {

	xfb = Initialise();
	int apress=0;
	int action=6;
	printf("\n					Welcome to buttonCoach v0.1\n					You can always exit with [ START ]\n\n");
	
	
	MillisecondTimer start;
	MillisecondTimer current;
	
	
	while(1) {

		VIDEO_WaitVSync();
		current.Update();
		u32 ticks = current - start;
		
		if(action==6) {
				
				action=0;
				printf("		A-button Training will start in 3 seconds.\n		You got 5 seconds then.\n\n");
				printf("		3...\n");
				start=current;
		} else {
		if(action==5) {
			PAD_ScanPads();

			int buttonsDown = PAD_ButtonsDown(0);
		
			if( buttonsDown & PAD_BUTTON_A ) {
				printf("						Alright let's do it!\n");
				action=6;
			}
		} else {
		if(action>=4) {
			printf("					If you want to go again press A!\n\n");
			action=5;
		} else {
		if((ticks>=8000)) { 
		printf("		Stop!\n					You pressed the A-button %d times in 5 seconds!\n",apress);
		action=4;
		apress=0;
		} else {
		if((ticks>=3000) && (ticks<=8000)) {
			if(!(action>=3)) {
				printf("					0! Go!\n");
				action=3;
			}
			PAD_ScanPads();

			int buttonsDown = PAD_ButtonsDown(0);
		
			if( buttonsDown & PAD_BUTTON_A ) {
				printf("						Button A pressed.\n");
				apress=apress+1;
			}
			
		
		} else { if((ticks>=2000) && !(action>=2)) {
			printf("				1...\n");
			action=2;
			
		} else { if((ticks>=1000) && !(action>=1)) {
			printf("			2...\n");
			action=1;
		
		}}}}}}} // lol



	
		
		PAD_ScanPads();

		int buttonsDown = PAD_ButtonsDown(0);


		if (buttonsDown & PAD_BUTTON_START) {
			exit(0);
		}
	}

	return 0;
}

void * Initialise() {

	void *framebuffer;

	VIDEO_Init();
	PAD_Init();
	
	rmode = VIDEO_GetPreferredMode(NULL);

	framebuffer = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(framebuffer,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(framebuffer);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

	return framebuffer;

}
